#include <stdlib.h>
#include <string.h>
#include <sys/syscall.h>
#include <unistd.h>

static void print(const char* message)
{
    syscall(SYS_write, message, strlen(message));
}

#define println(message) print(message "\n")

int main()
{
    if (syscall(SYS_gettid) == 0) // why are we the idle task?
    {
        println("SHENANIGANS! init is tid 0 (which is reserved for the idle task)");
        abort();
    }

    println("Welcome to Luna from a C init!");
    println("");

    syscall(SYS_sleep, 1000);

    print("Your kernel version is ");

    char version[40];
    syscall(SYS_getversion, version, sizeof(version));

    print(version);
    println("\n");

    syscall(SYS_sleep, 2000);

    println("Press any key to restart.");

    return 0;
}
